// arrays.h : include file for Objects use in Mediatek
//
// (c)05/1996 Stephane Faucourt

#ifndef __CARRAYS__
#define __CARRAYS__

// String limitation constants
#define MAX_TITLE	30
#define MAX_NAME	25
#define MAX_TYPE	25

// Video integer constants 
#define VD_FRM_PAL	 0
#define VD_FRM_SECAM 1
#define VD_FRM_NTSC	 2

#define VD_SCR_SCOPE 0
#define VD_SCR_169	 1
#define VD_SCR_185	 2
#define VD_SCR_PANSC 3

#define VD_SUP_CDV	 0
#define VD_SUP_K7	 1
#define VD_SUP_CDI	 2

#define VD_CHP_NO	 0

#define VD_SND_MONO	 0
#define VD_SND_STER	 1
#define VD_SND_DB	 2
#define VD_SND_SDDS	 3
#define VD_SND_THX 	 4

// CD Audio integer constants 
#define CD_SIZ_8	 0
#define CD_SIZ_12	 1

#define CD_FRM_CD	 0
#define CD_FRM_DAT	 1
#define CD_FRM_DCC	 2
#define CD_FRM_MIDI	 3
#define CD_FRM_TAPE	 4

// Computer software integer constants 
#define CS_FRM_CDROM 0
#define CS_FRM_DISK3 1
#define CD_FRM_DISK5 2
#define CS_FRM_HD	 3
#define CS_FRM_TAPE	 4

// Video purpose class description
struct CVideo
{
//public:
	char szTitle[MAX_TITLE];
	char szType[MAX_TYPE];
	char szEditor[MAX_NAME];
	int	 nYear;
	int	 nVideoF;	
	int	 nScreen;
	int	 nSupp;
	int	 nTime;
	int  nChap;
	char szRealis[MAX_NAME];
	int	 nSound;
    HTREEITEM hParent;
    HTREEITEM hItem;
};

// CD Audio purpose class description
struct CAudio
{
	char szTitle[MAX_TITLE];
	char szType[MAX_TYPE];
	char szArtist[MAX_NAME];
	int  nTime;
	int  nTracks;
	BOOL bStereo;
	int  nYear;
	int	 nSupp;
    HTREEITEM hParent;
    HTREEITEM hItem;
};

// Computer Software purpose class description
struct CSoftw
{
	char szTitle[MAX_TITLE];
	char szEditor[MAX_NAME];
	char szType[MAX_TYPE];
	int	 nFormat;
	int  nDisk;
	int  nYear;
    HTREEITEM hParent;
    HTREEITEM hItem;
};

// Books purpose class description
struct CBook
{
	char szTitle[MAX_TITLE];
	char szEditor[MAX_NAME];
	char szAuthor[MAX_NAME];
	char szType[MAX_TYPE];
	int  nYear;
	int  nChap;
    HTREEITEM hParent;
    HTREEITEM hItem;
};

#endif

